Ipopt 3.12.10

- Main Page
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros
Public Member Functions | Private Attributes | List of all members
Ipopt::MultiVectorMatrix Class Reference

Class for Matrices with few columns that consists of Vectors. More...

`#include <IpMultiVectorMatrix.hpp>`

Inheritance diagram for Ipopt::MultiVectorMatrix:
[legend]

## Public Member Functions
SmartPtr< MultiVectorMatrix > | MakeNewMultiVectorMatrix () const
| Create a new MultiVectorMatrix from same MatrixSpace. More...
SmartPtr< const Vector > | GetVector (Index i) const
| Get a Vector in a particular column as a const Vector. More...
SmartPtr< Vector > | GetVectorNonConst (Index i)
| Get a Vector in a particular column as a non-const Vector. More...
void | ScaleRows (const Vector &scal_vec)
| Method for scaling the rows of the matrix, using the ElementWiseMultiply method for each column vector. More...
void | ScaleColumns (const Vector &scal_vec)
| Method for scaling the columns of the matrix, using the Scal method for each column vector. More...
void | AddOneMultiVectorMatrix (Number a, const MultiVectorMatrix &mv1, Number c)
| Adding another MultiVectorMatrix, using the AddOneVector methods for the individual column vectors. More...
void | AddRightMultMatrix (Number a, const MultiVectorMatrix &U, const Matrix &C, Number b)
| Multiplying a Matrix C (for now assumed to be a DenseGenMatrix) from the right to a MultiVectorMatrix U and adding the result to this MultiVectorMatrix V. More...
void | FillWithNewVectors ()
| Method for initializing all Vectors with new (uninitialized) Vectors. More...
void | LRMultVector (Number alpha, const Vector &x, Number beta, Vector &y) const
| Method for adding the low-rank update matrix corresponding to this matrix to a vector. More...
SmartPtr< const VectorSpace > | ColVectorSpace () const
| Vector space for the columns. More...
SmartPtr< const MultiVectorMatrixSpace > | MultiVectorMatrixOwnerSpace () const
| Return the MultiVectorMatrixSpace. More...
Constructors / Destructors
| MultiVectorMatrix (const MultiVectorMatrixSpace *owner_space)
| Constructor, taking the owner_space. More...
| ~MultiVectorMatrix ()
| Destructor. More...
void | SetVector (Index i, const Vector &vec)
| Set a particular Vector at a given column position, replacing another vector if there has been one. More...
void | SetVectorNonConst (Index i, Vector &vec)
Public Member Functions inherited from Ipopt::Matrix
bool | HasValidNumbers () const
| Method for determining if all stored numbers are valid (i.e., no Inf or Nan). More...
SmartPtr< const MatrixSpace > | OwnerSpace () const
| Return the owner MatrixSpace. More...
| Matrix (const MatrixSpace *owner_space)
| Constructor. More...
virtual | ~Matrix ()
| Destructor. More...
void | MultVector (Number alpha, const Vector &x, Number beta, Vector &y) const
| Matrix-vector multiply. More...
void | TransMultVector (Number alpha, const Vector &x, Number beta, Vector &y) const
| Matrix(transpose) vector multiply. More...
void | AddMSinvZ (Number alpha, const Vector &S, const Vector &Z, Vector &X) const
| X = X + alpha*(Matrix S^{-1} Z). More...
void | SinvBlrmZMTdBr (Number alpha, const Vector &S, const Vector &R, const Vector &Z, const Vector &D, Vector &X) const
| X = S^{-1} (r + alpha*Z*M^Td). More...
Index | NRows () const
| Number of rows. More...
Index | NCols () const
| Number of columns. More...
void | ComputeRowAMax (Vector &rows_norms, bool init=true) const
| Compute the max-norm of the rows in the matrix. More...
void | ComputeColAMax (Vector &cols_norms, bool init=true) const
| Compute the max-norm of the columns in the matrix. More...
virtual void | Print (SmartPtr< const Journalist > jnlst, EJournalLevel level, EJournalCategory category, const std::string &name, Index indent=0, const std::string &prefix="") const
| Print detailed information about the matrix. More...
virtual void | Print (const Journalist &jnlst, EJournalLevel level, EJournalCategory category, const std::string &name, Index indent=0, const std::string &prefix="") const
Public Member Functions inherited from Ipopt::TaggedObject
| TaggedObject ()
| Constructor. More...
virtual | ~TaggedObject ()
| Destructor. More...
Tag | GetTag () const
| Users of TaggedObjects call this to update their own internal tags every time they perform the expensive operation. More...
bool | HasChanged (const Tag comparison_tag) const
| Users of TaggedObjects call this to check if the object HasChanged since they last updated their own internal tag. More...
Public Member Functions inherited from Ipopt::ReferencedObject
| ReferencedObject ()
virtual | ~ReferencedObject ()
Index | ReferenceCount () const
void | AddRef (const Referencer *referencer) const
void | ReleaseRef (const Referencer *referencer) const
Public Member Functions inherited from Ipopt::Subject
| Subject ()
| Default Constructor. More...
virtual | ~Subject ()
| Default destructor. More...
void | AttachObserver (Observer::NotifyType notify_type, Observer *observer) const
| Attach the specified observer (i.e., begin recieving notifications). More...
void | DetachObserver (Observer::NotifyType notify_type, Observer *observer) const
| Detach the specified observer (i.e., no longer recieve notifications). More...

## Protected Member Functions
Overloaded methods from Matrix base class
virtual void | MultVectorImpl (Number alpha, const Vector &x, Number beta, Vector &y) const
| Matrix-vector multiply. More...
virtual void | TransMultVectorImpl (Number alpha, const Vector &x, Number beta, Vector &y) const
| Matrix(transpose) vector multiply. More...
virtual bool | HasValidNumbersImpl () const
| Method for determining if all stored numbers are valid (i.e., no Inf or Nan). More...
virtual void | ComputeRowAMaxImpl (Vector &rows_norms, bool init) const
| Compute the max-norm of the rows in the matrix. More...
virtual void | ComputeColAMaxImpl (Vector &cols_norms, bool init) const
| Compute the max-norm of the columns in the matrix. More...
virtual void | PrintImpl (const Journalist &jnlst, EJournalLevel level, EJournalCategory category, const std::string &name, Index indent, const std::string &prefix) const
| Print detailed information about the matrix. More...
Protected Member Functions inherited from Ipopt::Matrix
virtual void | AddMSinvZImpl (Number alpha, const Vector &S, const Vector &Z, Vector &X) const
| X = X + alpha*(Matrix S^{-1} Z). More...
virtual void | SinvBlrmZMTdBrImpl (Number alpha, const Vector &S, const Vector &R, const Vector &Z, const Vector &D, Vector &X) const
| X = S^{-1} (r + alpha*Z*M^Td). More...
Protected Member Functions inherited from Ipopt::TaggedObject
void | ObjectChanged ()
| Objects derived from TaggedObject MUST call this method every time their internal state changes to update the internal tag for comparison. More...
Protected Member Functions inherited from Ipopt::Subject
void | Notify (Observer::NotifyType notify_type) const

## Private Member Functions
Default Compiler Generated Methods
(Hidden to avoid implicit creation/calling). These methods are not implemented and we do not want the compiler to implement them for us, so we declare them private and do not define them. This ensures that they will not be implicitly created/called.
| MultiVectorMatrix ()
| Default Constructor. More...
| MultiVectorMatrix (const MultiVectorMatrix &)
| Copy Constructor. More...
void | operator= (const MultiVectorMatrix &)
| Overloaded Equals Operator. More...
const Vector * | ConstVec (Index i) const
| Method for accessing the internal Vectors internally. More...
Vector * | Vec (Index i)

## Private Attributes
const MultiVectorMatrixSpace * | owner_space_
std::vector< SmartPtr< const Vector > > | const_vecs_
| space for storing the const Vector's More...
std::vector< SmartPtr< Vector > > | non_const_vecs_
| space for storing the non-const Vector's More...

## Additional Inherited Members
Public Types inherited from Ipopt::TaggedObject
typedef unsigned int | Tag
| Type for the Tag values. More...

## Detailed Description

Class for Matrices with few columns that consists of Vectors.

Those matrices are for example useful in the implementation of limited memory quasi-Newton methods.

Definition at line 25 of file IpMultiVectorMatrix.hpp.

## Constructor & Destructor Documentation

Ipopt::MultiVectorMatrix::MultiVectorMatrix | ( | const MultiVectorMatrixSpace * | owner_space | ) |

Constructor, taking the owner_space.

Ipopt::MultiVectorMatrix::~MultiVectorMatrix | ( |  | ) |
| inline

Destructor.

Definition at line 225 of file IpMultiVectorMatrix.hpp.

Ipopt::MultiVectorMatrix::MultiVectorMatrix | ( |  | ) |
| private

Default Constructor.

Ipopt::MultiVectorMatrix::MultiVectorMatrix | ( | const MultiVectorMatrix & |  | ) |
| private

Copy Constructor.

## Member Function Documentation

SmartPtr< MultiVectorMatrix > Ipopt::MultiVectorMatrix::MakeNewMultiVectorMatrix | ( |  | ) | const
| inline

Create a new MultiVectorMatrix from same MatrixSpace.

Definition at line 229 of file IpMultiVectorMatrix.hpp.

void Ipopt::MultiVectorMatrix::SetVector | ( | Index | i,
|  | const Vector & | vec
| ) |  |

Set a particular Vector at a given column position, replacing another vector if there has been one.

Depending on whether the Vector is const or not, it is stored in the const or non-const internal column.

void Ipopt::MultiVectorMatrix::SetVectorNonConst | ( | Index | i,
|  | Vector & | vec
| ) |  |

SmartPtr<const Vector> Ipopt::MultiVectorMatrix::GetVector | ( | Index | i | ) | const
| inline

Get a Vector in a particular column as a const Vector.

Definition at line 56 of file IpMultiVectorMatrix.hpp.

SmartPtr<Vector> Ipopt::MultiVectorMatrix::GetVectorNonConst | ( | Index | i | ) |
| inline

Get a Vector in a particular column as a non-const Vector.

This is fail if the column has currently only a non-const Vector stored.

Definition at line 64 of file IpMultiVectorMatrix.hpp.

void Ipopt::MultiVectorMatrix::ScaleRows | ( | const Vector & | scal_vec | ) |

Method for scaling the rows of the matrix, using the ElementWiseMultiply method for each column vector.

void Ipopt::MultiVectorMatrix::ScaleColumns | ( | const Vector & | scal_vec | ) |

Method for scaling the columns of the matrix, using the Scal method for each column vector.

void Ipopt::MultiVectorMatrix::AddOneMultiVectorMatrix | ( | Number | a,
|  | const MultiVectorMatrix & | mv1,
|  | Number | c
| ) |  |

Adding another MultiVectorMatrix, using the AddOneVector methods for the individual column vectors.

void Ipopt::MultiVectorMatrix::AddRightMultMatrix | ( | Number | a,
|  | const MultiVectorMatrix & | U,
|  | const Matrix & | C,
|  | Number | b
| ) |  |

Multiplying a Matrix C (for now assumed to be a DenseGenMatrix) from the right to a MultiVectorMatrix U and adding the result to this MultiVectorMatrix V.

V = a * U * C + b * V.

void Ipopt::MultiVectorMatrix::FillWithNewVectors | ( |  | ) |

Method for initializing all Vectors with new (uninitialized) Vectors.

void Ipopt::MultiVectorMatrix::LRMultVector | ( | Number | alpha,
|  | const Vector & | x,
|  | Number | beta,
|  | Vector & | y
| ) |  | const

Method for adding the low-rank update matrix corresponding to this matrix to a vector.

If V is this MultiVectorMatrix, the operation is y = beta*y + alpha*V*V^T*x.

SmartPtr< const VectorSpace > Ipopt::MultiVectorMatrix::ColVectorSpace | ( |  | ) | const
| inline

Vector space for the columns.

Definition at line 235 of file IpMultiVectorMatrix.hpp.

SmartPtr< const MultiVectorMatrixSpace > Ipopt::MultiVectorMatrix::MultiVectorMatrixOwnerSpace | ( |  | ) | const
| inline

Return the MultiVectorMatrixSpace.

Definition at line 242 of file IpMultiVectorMatrix.hpp.

virtual void Ipopt::MultiVectorMatrix::MultVectorImpl | ( | Number | alpha,
|  | const Vector & | x,
|  | Number | beta,
|  | Vector & | y
| ) |  | const
| protected virtual

Matrix-vector multiply.

Computes y = alpha * Matrix * x + beta * y

Implements Ipopt::Matrix.

virtual void Ipopt::MultiVectorMatrix::TransMultVectorImpl | ( | Number | alpha,
|  | const Vector & | x,
|  | Number | beta,
|  | Vector & | y
| ) |  | const
| protected virtual

Matrix(transpose) vector multiply.

Computes y = alpha * Matrix^T * x + beta * y

Implements Ipopt::Matrix.

virtual bool Ipopt::MultiVectorMatrix::HasValidNumbersImpl | ( |  | ) | const
| protected virtual

Method for determining if all stored numbers are valid (i.e., no Inf or Nan).

Reimplemented from Ipopt::Matrix.

virtual void Ipopt::MultiVectorMatrix::ComputeRowAMaxImpl | ( | Vector & | rows_norms,
|  | bool | init
| ) |  | const
| protected virtual

Compute the max-norm of the rows in the matrix.

The result is stored in rows_norms. The vector is assumed to be initialized.

Implements Ipopt::Matrix.

virtual void Ipopt::MultiVectorMatrix::ComputeColAMaxImpl | ( | Vector & | cols_norms,
|  | bool | init
| ) |  | const
| protected virtual

Compute the max-norm of the columns in the matrix.

The result is stored in cols_norms. The vector is assumed to be initialized.

Implements Ipopt::Matrix.

virtual void Ipopt::MultiVectorMatrix::PrintImpl | ( | const Journalist & | jnlst,
|  | EJournalLevel | level,
|  | EJournalCategory | category,
|  | const std::string & | name,
|  | Index | indent,
|  | const std::string & | prefix
| ) |  | const
| protected virtual

Print detailed information about the matrix.

Implements Ipopt::Matrix.

void Ipopt::MultiVectorMatrix::operator= | ( | const MultiVectorMatrix & |  | ) |
| private

Overloaded Equals Operator.

const Vector* Ipopt::MultiVectorMatrix::ConstVec | ( | Index | i | ) | const
| inline private

Method for accessing the internal Vectors internally.

Definition at line 161 of file IpMultiVectorMatrix.hpp.

Vector* Ipopt::MultiVectorMatrix::Vec | ( | Index | i | ) |
| inline private

Definition at line 173 of file IpMultiVectorMatrix.hpp.

## Member Data Documentation

const MultiVectorMatrixSpace* Ipopt::MultiVectorMatrix::owner_space_
| private

Definition at line 151 of file IpMultiVectorMatrix.hpp.

std::vector<SmartPtr<const Vector> > Ipopt::MultiVectorMatrix::const_vecs_
| private

space for storing the const Vector's

Definition at line 154 of file IpMultiVectorMatrix.hpp.

std::vector<SmartPtr<Vector> > Ipopt::MultiVectorMatrix::non_const_vecs_
| private

space for storing the non-const Vector's

Definition at line 157 of file IpMultiVectorMatrix.hpp.

The documentation for this class was generated from the following file:

- src/LinAlg/IpMultiVectorMatrix.hpp